
# line 8 "../../clib/g_parse.y"
#include "isis.h"

#define yyerrflag       isis_g_yyerrflag
#define yydef           isis_g_yydef
#define yynerrs         isis_g_yynerrs
#define yyr1            isis_g_yyr1
#define yyr2            isis_g_yyr2
#define yychar          isis_g_yychar
#define yyexca          isis_g_yyexca
#define yypact          isis_g_yypact
#define yyparse         isis_g_yyparse
#define yychk           isis_g_yychk
#define yypgo           isis_g_yypgo
#define yyact           isis_g_yyact
#define yyerror         isis_g_yyerror
#define yylex           isis_g_yylex
#define yylval          isis_g_yylval
#define yyval           isis_g_yyval
#define yyv             isis_g_yyv

# define T_AFTER 257
# define T_PID 258
# define T_OP 259
# define T_STRING 260
# define T_TIMEOUT 261
# define T_INTEGER 262
# define T_FMTE 263
# define T_FMTA 264
# define T_FMTD 265
# define T_AND 266
# define T_OR 267
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 70 "../../clib/g_parse.y"


#include <ctype.h>

char    *keywords[] ={
        "after", "pid", "op", "timeout", "and", "or", "&&", "||", 0
};

int     keyvals[] ={
        T_AFTER, T_PID, T_OP, T_TIMEOUT, T_AND, T_OR, T_AND, T_OR, 0
};

char    *string, *str;

g_preparse(what)
  char *what;
  {
        string = str = what;
        parse_error = 0;
        inv_level = 0;
        pre_parsing = 1;
        if(yyparse() || parse_error)
            return(-1);
        return(inv_level);
  }

g_parse(what)
  char *what;
  {
        string = str = what;
        parse_error = 0;
        pre_parsing = 0;
        if(yyparse() || parse_error)
            panic("parse error detected in guard parse");
  }

static yyerror()
  {
        parse_error++;
        isis_errno = IE_GPARSE;
  }

static yylex()
  {
        register char c;

        while(isspace(c = *str))
            ++str;
        if(c == 0)
            return(0);
        if(isdigit(c))
        {
            register n = c - '0';
            while(isdigit(c = *++str))
                n = n*10 + c-'0';
            yylval = n;
            return(T_INTEGER);
        }
        if(c == '%')
        {
            yylval = (int)str;
            switch(c = *++str)
            {
              case 'a':
                ++str;
                return(T_FMTA);
              case 'd':
                ++str;
                return(T_FMTD);
              case 'e':
                ++str;
                return(T_FMTE);
            }
            isis_errno = IE_GPARSE;
            parse_error++;
            return(0);
        }
        switch(c)
        {
           case '*':
           case '(': case ')':
           case '{': case '}':
           case '[': case ']':
           case ',': case '.':
               ++str;
               return(c);
        }
        if(!isalpha(c) && c != '$')
        {
            print("preparse: unexpected char %c (0%o)", c, c);
            parse_error++;
            return(0);
        }
        else
        {
            register char **kp, *ksp, *sp;
            char *malloc();
            for(kp = keywords; ksp = *kp; kp++)
            {
                sp = str;
                while(*sp && *ksp)
                {
                    c = *sp;
                    if(isupper(c))
                        c = tolower(c);
                    if(c != *ksp)
                        break;
                    ++sp;
                    ++ksp;
                }
                if(*ksp == 0)
                {
                    str = sp;
                    return(keyvals[kp-keywords]);
                }
            }
            sp = str;
            if(*str == '$')
                ++str;
            while(isalnum(*++str))
                continue;
            ksp = malloc((str-sp+4) & ~3);
            yylval = (int)ksp;
            while(sp != str)
                *ksp++ = *sp++;
            *ksp = 0;
            return(T_STRING);
        }
  }

static adesc g_ad
={
        sizeof(gnode),  sizeof(gnode),   16
};

#define n_alloc()       ((gnode*)mallocate(&g_ad));

n_free(bn)
  gnode *bn;
  {
        mdeallocate((char*)bn, &g_ad);
  }

/* Create a new gnode */
isis_enode(name, left, right)
  gnode *left, *right;
  {
        register gnode *np;
        if(pre_parsing)
            return(0);
        np = n_alloc();
        np->n_type = name;
        np->n_left = left;
        np->n_right = right;
        np->n_etree = g_etree;
        np->n_chain = g_etree->et_nodes;
        g_etree->et_nodes = np;
        return((int)np);
  }

isis_pnode(pn, op, msgid)
  address pn;
  {
        register gnode *np;
        if(pre_parsing)
            return(0);
        np = n_alloc();
        np->n_type = G_PATTERN;
        np->n_pat.e_msgid = msgid;
        np->n_pat.e_op = op;
        np->n_pat.e_pname = pn;
        np->n_etree = g_etree;
        np->n_chain = g_etree->et_nodes;
        g_etree->et_nodes = np;
        if(edb_lookup(g_etree->et_gp, &np->n_pat) == 0)
             qu_add_nd(g_etree->et_gp->gi_pats, 1, (char*)np);
        else
            np->n_flag |= G_EVAL_TRUE;
        return((int)np);
  }
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 18
# define YYLAST 239
short yyact[]={

  24,  20,  12,  13,  35,  25,   5,  39,  26,  34,
  33,  27,  38,   5,  37,  29,  19,  31,  30,  28,
  14,  17,  16,  32,   3,   7,   4,  11,   1,   0,
  15,   0,   0,   0,   0,   0,   0,  21,  22,  23,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,  36,   0,   0,   0,   9,   0,   0,
   0,   0,   0,   0,   9,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   2,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  12,  13,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   8,   0,  12,  13,   6,  35,  10,
   8,   0,   0,  34,   6,   0,  10,   0,  18 };
short yypact[]={

 -34,-1000, -27,-264, -21, -27, -18,-1000, -19, -26,
-1000,-124, -27, -27, -27, -41,-257,-252, -25, -29,
-1000,-1000,-1000,-264,-1000, -23, -24,-1000, -32,-256,
-1000,-1000, -79, -81,-1000,-1000, -86,-1000,-1000,-1000 };
short yypgo[]={

   0,  28,  24,  26,  25,  23 };
short yyr1[]={

   0,   1,   1,   2,   2,   2,   2,   2,   2,   2,
   2,   3,   4,   4,   4,   4,   5,   5 };
short yyr2[]={

   0,   3,   1,   3,   3,   3,   3,   4,   4,   1,
   0,   3,   5,   5,   5,   1,   1,   1 };
short yychk[]={

-1000,  -1, 123,  -2,  -3,  40, 261,  -4, 257,  91,
 263,  -2, 266, 267,  41,  -2,  40,  40, 264,  42,
 125,  -2,  -2,  -2,  41, 262, 265, 263,  44,  44,
  41,  41,  -5,  42, 265, 260,  -5,  93,  93,  93 };
short yydef[]={

  10,  -2,  10,   2,   0,  10,   0,   9,   0,   0,
  15,   0,  10,  10,  10,   0,   0,   0,   0,   0,
   1,   4,   5,   3,   6,   0,   0,  11,   0,   0,
   7,   8,   0,   0,  16,  17,   0,  12,  13,  14 };
#ifndef lint
static	char yaccpar_sccsid[] = "@(#)yaccpar 1.6 88/02/08 SMI"; /* from UCB 4.1 83/02/11 */
#endif

#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps>= &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 1:
# line 36 "../../clib/g_parse.y"
{ if(!pre_parsing) g_etree->et_expr = (gnode*)yypvt[-1]; } break;
case 2:
# line 37 "../../clib/g_parse.y"
{ if(!pre_parsing) g_etree->et_expr = (gnode*)yypvt[-0]; } break;
case 3:
# line 39 "../../clib/g_parse.y"
{ yyval = isis_enode(G_AFTER, yypvt[-2], yypvt[-1]); } break;
case 4:
# line 40 "../../clib/g_parse.y"
{ yyval = isis_enode(G_AND, yypvt[-2], yypvt[-1]); } break;
case 5:
# line 41 "../../clib/g_parse.y"
{ yyval = isis_enode(G_OR, yypvt[-2], yypvt[-1]); } break;
case 6:
# line 42 "../../clib/g_parse.y"
{ yyval = yypvt[-1]; } break;
case 7:
# line 43 "../../clib/g_parse.y"
{ if(!pre_parsing) { yyval = isis_tnode(yypvt[-1]); }} break;
case 8:
# line 44 "../../clib/g_parse.y"
{ if(!pre_parsing) {
                                                  int delay;
                                                  g_getev(yypvt[-1], &delay);
                                                  yyval = isis_tnode(delay); }} break;
case 9:
# line 48 "../../clib/g_parse.y"
{ yyval = yypvt[-0]; } break;
case 10:
# line 49 "../../clib/g_parse.y"
{ yyval = isis_enode(G_TRUE, 0, 0); } break;
case 11:
# line 51 "../../clib/g_parse.y"
{ if(!pre_parsing) yyval = g_alloc_eid(yypvt[-0]); } break;
case 12:
# line 53 "../../clib/g_parse.y"
{ if(!pre_parsing) {
                                                  event_id eid;
                                                  g_getev(yypvt[-3], &eid);
                                                  yyval = isis_pnode(eid.e_pname, yypvt[-1], 0); }} break;
case 13:
# line 57 "../../clib/g_parse.y"
{ if(!pre_parsing) {
                                                  event_id eid;
                                                  g_getev(yypvt[-3], &eid);
                                                  yyval = isis_pnode(eid.e_pname, -1, 0); }} break;
case 14:
# line 61 "../../clib/g_parse.y"
{ yyval = isis_pnode(NULLADDRESS, yypvt[-1], 0); } break;
case 15:
# line 62 "../../clib/g_parse.y"
{ if(!pre_parsing) {
                                                  event_id eid;
                                                  g_getev(yypvt[-0], &eid);
                                                  yyval = isis_pnode(eid.e_pname, eid.e_op, eid.e_msgid); }} break;
case 16:
# line 68 "../../clib/g_parse.y"
{ if(!pre_parsing) { int op; g_getev(yypvt[-0], &op); yyval = op; }} break;
case 17:
# line 69 "../../clib/g_parse.y"
{ if(!pre_parsing) { yyval = gop_lookup(yypvt[-0]); } free(yypvt[-0]); } break;
		}
		goto yystack;  /* stack new state and value */

	}
